diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/buildings-propagation-loss-model.cc ns-3.31/src/buildings/model/buildings-propagation-loss-model.cc
--- ns-3.30.1/src/buildings/model/buildings-propagation-loss-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/buildings-propagation-loss-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -188,9 +188,12 @@
 BuildingsPropagationLossModel::EvaluateSigma (Ptr<MobilityBuildingInfo> a, Ptr<MobilityBuildingInfo> b)
 const
 {
-  if (a->IsOutdoor ())
+  bool isAIndoor = a->IsIndoor ();
+  bool isBIndoor = b->IsIndoor ();
+
+  if (!isAIndoor) // a is outdoor
     {
-      if (b->IsOutdoor ())
+      if (!isBIndoor) // b is outdoor
         {
           return (m_shadowingSigmaOutdoor);
         }
@@ -201,7 +204,7 @@
         }
     }
   else
-  if (b->IsIndoor ())
+  if (isBIndoor) // b is indoor
     {
       return (m_shadowingSigmaIndoor);
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/hybrid-buildings-propagation-loss-model.cc ns-3.31/src/buildings/model/hybrid-buildings-propagation-loss-model.cc
--- ns-3.30.1/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -153,10 +153,13 @@
   NS_ASSERT_MSG ((a1 != 0) && (b1 != 0), "HybridBuildingsPropagationLossModel only works with MobilityBuildingInfo");
 
   double loss = 0.0;
+  bool isAIndoor = a1->IsIndoor ();
+  bool isBIndoor = b1->IsIndoor ();
 
-  if (a1->IsOutdoor ())
+
+  if (!isAIndoor) // a is outdoor
     {
-      if (b1->IsOutdoor ())
+      if (!isBIndoor) // b is outdoor
         {
           if (distance > 1000)
             {
@@ -208,7 +211,7 @@
   else
     {
       // a is indoor
-      if (b1->IsIndoor ())
+      if (isBIndoor) // b is indoor
         {
           if (a1->GetBuilding () == b1->GetBuilding ())
             {
@@ -247,8 +250,8 @@
               loss = ItuR1411 (a, b) + ExternalWallLoss (a1)  + HeightLoss (a1);
               NS_LOG_INFO (this << " I-O (<1000)  ITUR1411 + BEL + HG: " << loss);
             }
-        } // end b1->IsIndoor ()
-    } // end a1->IsOutdoor ()
+        } // end if (isBIndoor)
+    } // end if (!isAIndoor)
 
   loss = std::max (loss, 0.0);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/mobility-building-info.cc ns-3.31/src/buildings/model/mobility-building-info.cc
--- ns-3.30.1/src/buildings/model/mobility-building-info.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/mobility-building-info.cc	2020-06-27 17:38:30.000000000 -0700
@@ -21,6 +21,7 @@
 
 #include <ns3/simulator.h>
 #include <ns3/position-allocator.h>
+#include <ns3/building-list.h>
 #include <ns3/mobility-building-info.h>
 #include <ns3/pointer.h>
 #include <ns3/log.h>
@@ -43,6 +44,14 @@
   return tid;
 }
 
+void
+MobilityBuildingInfo::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  Ptr<MobilityModel> mm = this->GetObject<MobilityModel> ();
+  MakeConsistent (mm);
+}
+
 
 MobilityBuildingInfo::MobilityBuildingInfo ()
 {
@@ -51,6 +60,7 @@
   m_nFloor = 1;
   m_roomX = 1;
   m_roomY = 1;
+  m_cachedPosition = Vector (0, 0, 0);
 }
 
 
@@ -68,14 +78,23 @@
 MobilityBuildingInfo::IsIndoor (void)
 {
   NS_LOG_FUNCTION (this);
-  return (m_indoor);
+  Ptr<MobilityModel> mm = this->GetObject<MobilityModel> ();
+  Vector currentPosition = mm->GetPosition ();
+  bool posNotEqual = (currentPosition < m_cachedPosition) || (m_cachedPosition < currentPosition);
+  if (posNotEqual)
+    {
+      MakeConsistent (mm);
+    }
+
+  return m_indoor;
 }
 
 bool
 MobilityBuildingInfo::IsOutdoor (void)
 {
   NS_LOG_FUNCTION (this);
-  return (!m_indoor);
+  bool isIndoor = IsIndoor ();
+  return (!isIndoor);
 }
 
 void
@@ -155,5 +174,34 @@
   return (m_myBuilding);
 }
 
+void
+MobilityBuildingInfo::MakeConsistent (Ptr<MobilityModel> mm)
+{
+  bool found = false;
+  Vector pos = mm->GetPosition ();
+  for (BuildingList::Iterator bit = BuildingList::Begin (); bit != BuildingList::End (); ++bit)
+    {
+      NS_LOG_LOGIC ("checking building " << (*bit)->GetId () << " with boundaries " << (*bit)->GetBoundaries ());
+      if ((*bit)->IsInside (pos))
+        {
+          NS_LOG_LOGIC ("MobilityBuildingInfo " << this << " pos " << pos << " falls inside building " << (*bit)->GetId ());
+          NS_ABORT_MSG_UNLESS (found == false, " MobilityBuildingInfo already inside another building!");
+          found = true;
+          uint16_t floor = (*bit)->GetFloor (pos);
+          uint16_t roomX = (*bit)->GetRoomX (pos);
+          uint16_t roomY = (*bit)->GetRoomY (pos);
+          SetIndoor (*bit, floor, roomX, roomY);
+        }
+    }
+  if (!found)
+    {
+      NS_LOG_LOGIC ("MobilityBuildingInfo " << this << " pos " << pos  << " is outdoor");
+      SetOutdoor ();
+    }
+
+  m_cachedPosition = pos;
+
+}
+
   
 } // namespace
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/mobility-building-info.h ns-3.31/src/buildings/model/mobility-building-info.h
--- ns-3.30.1/src/buildings/model/mobility-building-info.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/mobility-building-info.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,6 +30,7 @@
 #include <map>
 #include <ns3/building.h>
 #include <ns3/constant-velocity-helper.h>
+#include <ns3/mobility-model.h>
 
 
 
@@ -47,25 +48,44 @@
 class MobilityBuildingInfo : public Object
 {
 public:
+  /**
+   * \brief Get the type ID.
+   *
+   * \return the object TypeId
+   */
   static TypeId GetTypeId (void);
   MobilityBuildingInfo ();
 
+  /**
+   * \brief Parameterized constructor
+   *
+   * \param building The building in which the MobilityBuildingInfo instance would be placed
+   */
   MobilityBuildingInfo (Ptr<Building> building);
 
   /** 
-   * 
+   * \brief Is indoor method.
+   *
    * \return true if the MobilityBuildingInfo instance is indoor, false otherwise
    */
   bool IsIndoor (void);
 
   /** 
    * 
+   * \brief Is outdoor function
+   *
    * \return true if the MobilityBuildingInfo instance is outdoor, false otherwise
+   *
+   * \deprecated This method will go away in a future release of ns-3.
+   *  Calling \c IsIndoor () method of \c MobilityBuildingInfo class
+   *  will satisfy the need to determine if a node is inside or outside
+   *  a building.
    */
+  NS_DEPRECATED_3_31
   bool IsOutdoor (void);
 
   /** 
-   * Mark this MobilityBuildingInfo instance as indoor
+   * \brief Mark this MobilityBuildingInfo instance as indoor
    * 
    * \param building the building into which the MobilityBuildingInfo instance is located
    * \param nfloor the floor number 1...nFloors at which the  MobilityBuildingInfo instance is located
@@ -74,48 +94,71 @@
    */
   void SetIndoor (Ptr<Building> building, uint8_t nfloor, uint8_t nroomx, uint8_t nroomy);
 
+  /**
+   * \brief Mark this MobilityBuildingInfo instance as indoor
+   *
+   * \param nfloor the floor number 1...nFloors at which the MobilityBuildingInfo instance is located
+   * \param nroomx the X room number 1...nRoomsX at which the MobilityBuildingInfo instance is located
+   * \param nroomy the Y room number 1...nRoomsY at which the MobilityBuildingInfo instance is located
+   */
 
   void SetIndoor (uint8_t nfloor, uint8_t nroomx, uint8_t nroomy);
 
   /** 
-   * Mark this MobilityBuildingInfo instance as outdoor
-   * 
+   * \brief Mark this MobilityBuildingInfo instance as outdoor
    */
   void SetOutdoor ();
 
   /** 
-   * 
-   * \return 
+   * \brief Get the floor number at which the MobilityBuildingInfo instance is located
+   *
+   * \return The floor number
    */
   uint8_t GetFloorNumber (void);
 
   /** 
+   * \brief Get the room number along x-axis at which the MobilityBuildingInfo instance is located
    * 
-   * \return 
+   * \return The room number
    */
   uint8_t GetRoomNumberX (void);
 
   /** 
+   * \brief Get the room number along y-axis at which the MobilityBuildingInfo instance is located
    * 
-   * \return 
+   * \return The room number
    */
   uint8_t GetRoomNumberY (void);
 
   /** 
+   * \brief Get the building in which the MobilityBuildingInfo instance is located
    * 
-   * \return 
+   * \return The building in which the MobilityBuildingInfo instance is located
    */
   Ptr<Building> GetBuilding ();
+  /**
+   * \brief Make the given mobility model consistent, by determining whether
+   * its position falls inside any of the building in BuildingList, and
+   * updating accordingly the BuildingInfo aggregated with the MobilityModel.
+   *
+   * \param mm the mobility model to be made consistent
+   */
+  void MakeConsistent (Ptr<MobilityModel> mm);
+
+protected:
+  // inherited from Object
+  virtual void DoInitialize ();
 
 
 
 private:
 
-  Ptr<Building> m_myBuilding;
-  bool m_indoor;
-  uint8_t m_nFloor;
-  uint8_t m_roomX;
-  uint8_t m_roomY;
+  Ptr<Building> m_myBuilding; ///< Building
+  bool m_indoor; ///< Node position (indoor/outdoor) ?
+  uint8_t m_nFloor; ///< The floor number at which the MobilityBuildingInfo instance is located
+  uint8_t m_roomX; ///< The room number along x-axis at which the MobilityBuildingInfo instance is located
+  uint8_t m_roomY; ///< The room number along y-axis at which the MobilityBuildingInfo instance is located
+  Vector m_cachedPosition; ///< The node position cached after making its mobility model consistent
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/oh-buildings-propagation-loss-model.cc ns-3.31/src/buildings/model/oh-buildings-propagation-loss-model.cc
--- ns-3.30.1/src/buildings/model/oh-buildings-propagation-loss-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/oh-buildings-propagation-loss-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -74,9 +74,12 @@
 
   double loss = 0.0;
 
-  if (a1->IsOutdoor ())
+  bool isAIndoor = a1->IsIndoor ();
+  bool isBIndoor = b1->IsIndoor ();
+
+  if (!isAIndoor) // a is outdoor
     {
-      if (b1->IsOutdoor ())
+      if (!isBIndoor) // b is outdoor
         {
           loss = m_okumuraHata->GetLoss (a, b);
           NS_LOG_INFO (this << " O-O : " << loss);
@@ -91,7 +94,7 @@
   else
     {
       // a is indoor
-      if (b1->IsIndoor ())
+      if (isBIndoor) // b is indoor
         {
           if (a1->GetBuilding () == b1->GetBuilding ())
             {
@@ -111,8 +114,8 @@
         {
           loss = m_okumuraHata->GetLoss (a, b) + ExternalWallLoss (a1);
           NS_LOG_INFO (this << " I-O : " << loss);
-        } // end b1->IsIndoor ()
-    } // end a1->IsOutdoor ()
+        } // end if (isBIndoor)
+    } // end if (!isAIndoor)
 
   loss = std::max (0.0, loss);
   return loss;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc ns-3.31/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc
--- ns-3.30.1/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,438 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2006,2007 INRIA
+ * Copyright (c) 2019 University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ * Author: Michele Polese <michele.polese@gmail.com>
+ */
+#include "random-walk-2d-outdoor-mobility-model.h"
+#include "ns3/enum.h"
+#include "ns3/double.h"
+#include "ns3/uinteger.h"
+#include "ns3/string.h"
+#include "ns3/pointer.h"
+#include "ns3/simulator.h"
+#include "ns3/log.h"
+#include "ns3/building.h"
+#include "ns3/building-list.h"
+#include <cmath>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("RandomWalk2dOutdoor");
+
+NS_OBJECT_ENSURE_REGISTERED (RandomWalk2dOutdoorMobilityModel);
+
+TypeId
+RandomWalk2dOutdoorMobilityModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::RandomWalk2dOutdoorMobilityModel")
+    .SetParent<MobilityModel> ()
+    .SetGroupName ("Mobility")
+    .AddConstructor<RandomWalk2dOutdoorMobilityModel> ()
+    .AddAttribute ("Bounds",
+                   "Bounds of the area to cruise.",
+                   RectangleValue (Rectangle (0.0, 100.0, 0.0, 100.0)),
+                   MakeRectangleAccessor (&RandomWalk2dOutdoorMobilityModel::m_bounds),
+                   MakeRectangleChecker ())
+    .AddAttribute ("Time",
+                   "Change current direction and speed after moving for this delay.",
+                   TimeValue (Seconds (20.0)),
+                   MakeTimeAccessor (&RandomWalk2dOutdoorMobilityModel::m_modeTime),
+                   MakeTimeChecker ())
+    .AddAttribute ("Distance",
+                   "Change current direction and speed after moving for this distance.",
+                   DoubleValue (30.0),
+                   MakeDoubleAccessor (&RandomWalk2dOutdoorMobilityModel::m_modeDistance),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("Mode",
+                   "The mode indicates the condition used to "
+                   "change the current speed and direction",
+                   EnumValue (RandomWalk2dOutdoorMobilityModel::MODE_DISTANCE),
+                   MakeEnumAccessor (&RandomWalk2dOutdoorMobilityModel::m_mode),
+                   MakeEnumChecker (RandomWalk2dOutdoorMobilityModel::MODE_DISTANCE, "Distance",
+                                    RandomWalk2dOutdoorMobilityModel::MODE_TIME, "Time"))
+    .AddAttribute ("Direction",
+                   "A random variable used to pick the direction (radians).",
+                   StringValue ("ns3::UniformRandomVariable[Min=0.0|Max=6.283184]"),
+                   MakePointerAccessor (&RandomWalk2dOutdoorMobilityModel::m_direction),
+                   MakePointerChecker<RandomVariableStream> ())
+    .AddAttribute ("Speed",
+                   "A random variable used to pick the speed (m/s)."
+                   "The default value is taken from Figure 1 of the paper"
+                   "Henderson, L.F., 1971. The statistics of crowd fluids. nature, 229(5284), p.381.",
+                   StringValue ("ns3::NormalRandomVariable[Mean=1.53|Variance=0.040401]"),
+                   MakePointerAccessor (&RandomWalk2dOutdoorMobilityModel::m_speed),
+                   MakePointerChecker<RandomVariableStream> ())
+    .AddAttribute ("Tolerance",
+                   "Tolerance for the intersection point with buildings (m)."
+                   "It represents a small distance from where the building limit"
+                   "is actually placed, for example to represent a sidewalk.",
+                   DoubleValue (1e-6),
+                   MakeDoubleAccessor (&RandomWalk2dOutdoorMobilityModel::m_epsilon),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("MaxIterations",
+                   "Maximum number of attempts to find an alternative next position"
+                   "if the original one is inside a building.",
+                   UintegerValue (100),
+                   MakeUintegerAccessor (&RandomWalk2dOutdoorMobilityModel::m_maxIter),
+                   MakeUintegerChecker<uint32_t> ())
+  ;
+  return tid;
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::DoInitialize (void)
+{
+  DoInitializePrivate ();
+  MobilityModel::DoInitialize ();
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::DoInitializePrivate (void)
+{
+  m_helper.Update ();
+  double speed = m_speed->GetValue ();
+  double direction = m_direction->GetValue ();
+  Vector vector (std::cos (direction) * speed,
+                 std::sin (direction) * speed,
+                 0.0);
+  m_helper.SetVelocity (vector);
+  m_helper.Unpause ();
+
+  Time delayLeft;
+  if (m_mode == RandomWalk2dOutdoorMobilityModel::MODE_TIME)
+    {
+      delayLeft = m_modeTime;
+    }
+  else
+    {
+      delayLeft = Seconds (m_modeDistance / speed);
+    }
+  DoWalk (delayLeft);
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::DoWalk (Time delayLeft)
+{
+  NS_LOG_FUNCTION (this << delayLeft.GetSeconds ());
+
+  Vector position = m_helper.GetCurrentPosition ();
+  Vector speed = m_helper.GetVelocity ();
+  Vector nextPosition = position;
+  nextPosition.x += speed.x * delayLeft.GetSeconds ();
+  nextPosition.y += speed.y * delayLeft.GetSeconds ();
+  m_event.Cancel ();
+
+  // check if the nextPosition is inside a building, or if the line
+  // from position to the next position intersects a building
+  auto outdoorBuilding = IsLineClearOfBuildings (position, nextPosition);
+  bool outdoor = std::get<0> (outdoorBuilding);
+  Ptr<Building> building = std::get<1> (outdoorBuilding);
+
+  if (m_bounds.IsInside (nextPosition))
+    {
+      if (outdoor)
+        {
+          m_event = Simulator::Schedule (delayLeft, &RandomWalk2dOutdoorMobilityModel::DoInitializePrivate, this);
+        }
+      else
+        {
+          NS_LOG_LOGIC ("NextPosition would lead into a building");
+          nextPosition = CalculateIntersectionFromOutside (position, nextPosition, building->GetBoundaries ());
+          Time delay = Seconds ((nextPosition.x - position.x) / speed.x);
+          m_event = Simulator::Schedule (delay, &RandomWalk2dOutdoorMobilityModel::AvoidBuilding, this,
+                                         delayLeft - delay,
+                                         nextPosition
+                                         );
+        }
+    }
+  else
+    {
+      NS_LOG_LOGIC ("Out of bounding box");
+      nextPosition = m_bounds.CalculateIntersection (position, speed);
+      // check that this nextPosition is outdoor
+      auto outdoorBuilding = IsLineClearOfBuildings (position, nextPosition);
+      bool outdoor = std::get<0> (outdoorBuilding);
+      Ptr<Building> building = std::get<1> (outdoorBuilding);
+
+      if (outdoor)
+        {
+          Time delay = Seconds ((nextPosition.x - position.x) / speed.x);
+          m_event = Simulator::Schedule (delay, &RandomWalk2dOutdoorMobilityModel::Rebound, this,
+                                         delayLeft - delay);
+        }
+      else
+        {
+          NS_LOG_LOGIC ("NextPosition would lead into a building");
+          nextPosition = CalculateIntersectionFromOutside (position, nextPosition, building->GetBoundaries ());
+          Time delay = Seconds ((nextPosition.x - position.x) / speed.x);
+          m_event = Simulator::Schedule (delay, &RandomWalk2dOutdoorMobilityModel::AvoidBuilding, this,
+                                         delayLeft - delay,
+                                         nextPosition
+                                         );
+        }
+    }
+  NS_LOG_LOGIC ("Position " << position << " NextPosition " << nextPosition);
+
+  // store the previous position
+  m_prevPosition = position;
+  NotifyCourseChange ();
+}
+
+std::pair<bool, Ptr<Building> >
+RandomWalk2dOutdoorMobilityModel::IsLineClearOfBuildings ( Vector currentPosition, Vector nextPosition ) const
+{
+  NS_LOG_FUNCTION (this << currentPosition << nextPosition);
+
+  bool intersectBuilding = false;
+  double minIntersectionDistance = std::numeric_limits<double>::max ();
+  Ptr<Building> minIntersectionDistanceBuilding;
+
+  for (BuildingList::Iterator bit = BuildingList::Begin (); bit != BuildingList::End (); ++bit)
+    {
+      // check if this building intersects the line between the current and next positions
+      // this checks also if the next position is inside the building
+      if ((*bit)->IsIntersect (currentPosition, nextPosition))
+        {
+          NS_LOG_LOGIC ("Building " << (*bit)->GetBoundaries ()
+                                    << " intersects the line between " << currentPosition
+                                    << " and " << nextPosition);
+          auto intersection = CalculateIntersectionFromOutside (
+            currentPosition, nextPosition, (*bit)->GetBoundaries ());
+          double distance = CalculateDistance (intersection, currentPosition);
+          intersectBuilding = true;
+          if (distance < minIntersectionDistance)
+            {
+              minIntersectionDistance = distance;
+              minIntersectionDistanceBuilding = (*bit);
+            }
+        }
+    }
+
+  return std::make_pair (!intersectBuilding, minIntersectionDistanceBuilding);
+}
+
+Vector
+RandomWalk2dOutdoorMobilityModel::CalculateIntersectionFromOutside (const Vector &current, const Vector &next, Box boundaries) const
+{
+  NS_LOG_FUNCTION (this << " current " << current << " next " << next);
+  bool inside = boundaries.IsInside (current);
+  NS_ASSERT (!inside);
+
+  // get the closest side
+  Rectangle rect = Rectangle (boundaries.xMin, boundaries.xMax, boundaries.yMin, boundaries.yMax);
+  NS_LOG_INFO ("rect " << rect);
+  Rectangle::Side closestSide = rect.GetClosestSide (current);
+
+  double xIntersect  = 0;
+  double yIntersect = 0;
+
+  switch (closestSide)
+    {
+      case Rectangle::RIGHT:
+        NS_LOG_INFO ("The closest side is RIGHT");
+        NS_ABORT_MSG_IF (next.x - current.x == 0, "x position not updated");
+        xIntersect = boundaries.xMax + m_epsilon;
+        yIntersect =
+          (next.y - current.y) / (next.x - current.x) * (xIntersect - current.x) + current.y;
+        break;
+      case Rectangle::LEFT:
+        NS_LOG_INFO ("The closest side is LEFT");
+        xIntersect = boundaries.xMin - m_epsilon;
+        NS_ABORT_MSG_IF (next.x - current.x == 0, "x position not updated");
+        yIntersect =
+          (next.y - current.y) / (next.x - current.x) * (xIntersect - current.x) + current.y;
+        break;
+      case Rectangle::TOP:
+        NS_LOG_INFO ("The closest side is TOP");
+        yIntersect = boundaries.yMax + m_epsilon;
+        NS_ABORT_MSG_IF (next.y - current.y == 0, "y position not updated");
+        xIntersect =
+          (next.x - current.x) / (next.y - current.y) * (yIntersect - current.y) + current.x;
+        break;
+      case Rectangle::BOTTOM:
+        NS_LOG_INFO ("The closest side is BOTTOM");
+        yIntersect = boundaries.yMin - m_epsilon;
+        NS_ABORT_MSG_IF (next.y - current.y == 0, "y position not updated");
+        xIntersect =
+          (next.x - current.x) / (next.y - current.y) * (yIntersect - current.y) + current.x;
+        break;
+    }
+  NS_LOG_INFO ("xIntersect " << xIntersect << " yIntersect " << yIntersect);
+  return Vector (xIntersect, yIntersect, 0);
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::Rebound (Time delayLeft)
+{
+  NS_LOG_FUNCTION (this << delayLeft.GetSeconds ());
+  m_helper.UpdateWithBounds (m_bounds);
+  Vector position = m_helper.GetCurrentPosition ();
+  Vector speed = m_helper.GetVelocity ();
+  switch (m_bounds.GetClosestSide (position))
+    {
+      case Rectangle::RIGHT:
+        NS_LOG_INFO ("The closest side is RIGHT");
+      case Rectangle::LEFT:
+        NS_LOG_INFO ("The closest side is LEFT");
+        speed.x = -speed.x;
+        break;
+      case Rectangle::TOP:
+        NS_LOG_INFO ("The closest side is TOP");
+      case Rectangle::BOTTOM:
+        NS_LOG_INFO ("The closest side is BOTTOM");
+        speed.y = -speed.y;
+        break;
+    }
+  m_helper.SetVelocity (speed);
+  m_helper.Unpause ();
+  DoWalk (delayLeft);
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::AvoidBuilding (Time delayLeft, Vector intersectPosition)
+{
+  NS_LOG_FUNCTION (this << delayLeft.GetSeconds ());
+  m_helper.Update ();
+
+  bool nextWouldBeInside = true;
+  uint32_t iter = 0;
+
+  while (nextWouldBeInside && iter < m_maxIter)
+    {
+      NS_LOG_INFO ("The next position would be inside a building, compute an alternative");
+      iter++;
+      double speed = m_speed->GetValue ();
+      double direction = m_direction->GetValue ();
+      Vector velocityVector (std::cos (direction) * speed,
+                             std::sin (direction) * speed,
+                             0.0);
+      m_helper.SetVelocity (velocityVector);
+
+      Vector nextPosition = intersectPosition;
+      nextPosition.x += velocityVector.x * delayLeft.GetSeconds ();
+      nextPosition.y += velocityVector.y * delayLeft.GetSeconds ();
+
+      // check if this is inside the current buildingBox
+      auto outdoorBuilding = IsLineClearOfBuildings (intersectPosition, nextPosition);
+      bool outdoor = std::get<0> (outdoorBuilding);
+
+      if (!outdoor)
+        {
+          NS_LOG_LOGIC ("inside loop intersect " << intersectPosition << " nextPosition "
+                                                 << nextPosition << " " << outdoor << " building " << std::get<1> (outdoorBuilding)->GetBoundaries ());
+        }
+      else
+        {
+          NS_LOG_LOGIC ("inside loop intersect " << intersectPosition << " nextPosition "
+                                                 << nextPosition << " " << outdoor);
+        }
+
+      if (outdoor && m_bounds.IsInside (nextPosition))
+        {
+          nextWouldBeInside = false;
+        }
+    }
+
+  // after m_maxIter iterations, the positions tested are all inside
+  // to avoid increasing m_maxIter too much, it is possible to perform a step back
+  // to the previous position and continue from there
+  if (iter >= m_maxIter)
+    {
+      NS_LOG_INFO ("Move back to the previous position");
+
+      // compute the difference between the previous position and the intersection
+      Vector posDiff = m_prevPosition - intersectPosition;
+      // compute the distance
+      double distance = CalculateDistance (m_prevPosition, intersectPosition);
+      double speed = distance / delayLeft.GetSeconds (); // compute the speed
+
+      NS_LOG_LOGIC ("prev " << m_prevPosition
+                            << " intersectPosition " << intersectPosition
+                            << " diff " << posDiff << " dist " << distance
+                    );
+
+      Vector velocityVector (posDiff.x / distance * speed,
+                             posDiff.y / distance * speed,
+                             0.0);
+      m_helper.SetVelocity (velocityVector);
+
+      Vector nextPosition = intersectPosition;
+      nextPosition.x += velocityVector.x * delayLeft.GetSeconds ();
+      nextPosition.y += velocityVector.y * delayLeft.GetSeconds ();
+
+      // check if the path is clear
+      auto outdoorBuilding = IsLineClearOfBuildings (intersectPosition, nextPosition);
+      bool outdoor = std::get<0> (outdoorBuilding);
+      if (!outdoor)
+        {
+          NS_LOG_LOGIC ("The position is still inside after "
+                        << m_maxIter + 1 << " iterations, loop intersect "
+                        << intersectPosition << " nextPosition "
+                        << nextPosition << " " << outdoor
+                        << " building " << std::get<1> (outdoorBuilding)->GetBoundaries ());
+          // This error may be due to buildings being attached to one another, or to the boundary of the scenario.
+          NS_FATAL_ERROR ("Not able to find an outdoor position. Try to increase the attribute MaxIterations and check the position of the buildings in the scenario.");
+        }
+      else
+        {
+          NS_LOG_LOGIC ("inside loop intersect " << intersectPosition << " nextPosition "
+                                                 << nextPosition << " " << outdoor);
+        }
+    }
+
+  m_helper.Unpause ();
+
+  DoWalk (delayLeft);
+}
+
+void
+RandomWalk2dOutdoorMobilityModel::DoDispose (void)
+{
+  // chain up
+  MobilityModel::DoDispose ();
+}
+Vector
+RandomWalk2dOutdoorMobilityModel::DoGetPosition (void) const
+{
+  m_helper.UpdateWithBounds (m_bounds);
+  return m_helper.GetCurrentPosition ();
+}
+void
+RandomWalk2dOutdoorMobilityModel::DoSetPosition (const Vector &position)
+{
+  NS_ASSERT (m_bounds.IsInside (position));
+  m_helper.SetPosition (position);
+  Simulator::Remove (m_event);
+  m_event = Simulator::ScheduleNow (&RandomWalk2dOutdoorMobilityModel::DoInitializePrivate, this);
+}
+Vector
+RandomWalk2dOutdoorMobilityModel::DoGetVelocity (void) const
+{
+  return m_helper.GetVelocity ();
+}
+int64_t
+RandomWalk2dOutdoorMobilityModel::DoAssignStreams (int64_t stream)
+{
+  m_speed->SetStream (stream);
+  m_direction->SetStream (stream + 1);
+  return 2;
+}
+
+
+} // namespace ns3
\ No newline at end of file
